 import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Hero here.
 * 
 * @author Sam Been 
 * @version Build 0.98
 */
public class Hero  extends Actor
//This establishes attributes to the character before any other actions can
//be made.
{
    //All of these are variables of the Hero. They change
    //based on the input of a player. be very careful not
    //to mess with these numbers; it could ruin the whole engine.
    private double power = 0.12;        //The ammount his total speed will increase.
    private double xSpeed = 0.0;        //Hero's current horizontal speed. Minus = Left, Plus = Right.
    private double ySpeed = 0.0;        //Hero's current vertical speed. Minus = Up, Plus = Down.
    private double maxSpeed = 9.0;      //Hero's highest acceleration point, AKA the "Speed Cap".
    private double gravity = 0.2;       //The ammount of gravity pulling Hero down.
    private double slowdown = 0.07;     //The speed Hero decelerates.
    private int score = 0;              //The ammount of points earned.
    private int count = 0;              //The ring bucket.
    private int rotation = 0;           //To make sure Hero's rotation is at 0 before the game starts.
    private double x;
    private double y;
    private boolean offGround = false;  //For the game to refference to. If Hero is off the ground or not...
    private boolean lookRight = true;   //Used to check if Hero should be turned right or left during animations.
    private boolean rolling = false;    //Checks to see if Hero is in a rolling position.
    private boolean spikeHit = false;   //Checks to see if the person hit the spikes or not.
    private boolean alive = true;       // Is Hero still alive or not?
    private boolean springLaunch = false;//Has the Hero been launched off of a spring?
    private boolean debug = false;
    private Label myLabel;              //Tells Hero to change Label via the myLabel command.
    private HUDscore hudScore;
    //public World HeroWorld = getWorld();//used to find Hero's location when he dies. 
    //private String animation;           //Is the animation system used to animate Hero.
    
    
    public Hero()
    {
        //For testing only.
    }
    
    public Hero(Label label, HUDscore hudScore)
    {
        //Recommended if you want to keep track of Score.
        //Is for use in stages.
        myLabel = label;
        this.hudScore = hudScore;
    }
    
    /**
     * Act - do whatever the Hero wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     * This is like a "Create" Function, it will do this as soon as the object
     * has been asked to act.
     */
    
    public void act() 
    {
        // These are the actions Hero will take constantly.
        checkKeys();
    }   
    
    public void checkKeys()
    //Looks to see wether any keyboard keys are pressed. If they are, than
    //preform the action. Otherwise, skip.
    {
        if (alive == true)
        {
            Actor platform01 = getOneIntersectingObject(Platform01.class);
            Actor spring = getOneObjectAtOffset(0,0, Spring01.class);
            Actor springLeft = getOneObjectAtOffset(-16,-16, Spring01.class);
            Actor springRight = getOneObjectAtOffset(16,-16, Spring01.class);
            Actor ringMonitor = getOneIntersectingObject(RingMonitor.class);
            Actor ringMonitorLeft = getOneObjectAtOffset(-16,0, RingMonitor.class);
            Actor ringMonitorRight = getOneObjectAtOffset(16,0, RingMonitor.class);
            Actor wallDetect = getOneIntersectingObject(WallDetect.class);
            Actor wallDetectRightWall = getOneIntersectingObject(WallDetectRightWall.class);
            Actor slope20dn1 = getOneIntersectingObject(Ground10.class);
            if (platform01 != null)
            {
                //This insures that if you touch this object (Ground), you won't fall through it.
                //It also returns acceleration to 0.12, in case collision happened after a jump.
                //This applies to all other Ground objects as well.
               ySpeed = 0;
               power = 0.12;
               rotation = 0;
               setImage("SonicStand0.PNG");
               springLaunch = false;
               offGround = false;
               spikeHit = false;
               if (Greenfoot.isKeyDown("space"))
               {
                    power = 0.15;   //Gives Hero a little extra 'Ooomph' when jumping or launching off a spring.
                    offGround = true;   //To make sure Hero is in fact, on or off of ground.
                    Greenfoot.playSound("Jump.wav");
                    ySpeed = -7; //the jump value
                    //This says to increase the value of ySpeed if your pressing the 
                    //"Up" Key.
               }
               if (offGround == false)
               {
                   if ((xSpeed < 0.1) && (xSpeed > -0.1) && (ySpeed < 0.1) && (ySpeed > -0.1 ))
                   {
                       if(lookRight == false)
                            setImage("SonicStandLeft0.PNG");
                       if(lookRight == true)
                            setImage("SonicStand0.PNG"); 
                       rolling = false;
                       if(Greenfoot.isKeyDown("down"))
                       {
                           if (lookRight == false)
                                setImage("SonicDuckLeft0.PNG");
                           if (lookRight == true)
                                setImage("SonicDuck0.PNG");
                       }
                       if(Greenfoot.isKeyDown("up"))
                       {
                          if (lookRight == false)
                                setImage("SonicLookUpLeft0.PNG");
                          if (lookRight == true)
                                setImage("SonicLookUp0.PNG");
                       }
                   }
                   if((lookRight == true) && (xSpeed > 0.1))
                   {
                        if (Greenfoot.isKeyDown("down"))
                        {
                            rolling = true;
                            Greenfoot.playSound("Roll.wav");
      
                        }
                        setImage("SonicJump0.png");
                   }
                   if ((lookRight == false) && (xSpeed < -0.1))
                   {
                        //This puts hero into a roll to the left if he has any acceloration.
                        if (Greenfoot.isKeyDown("down"))
                        {
                            rolling = true; //Makes sure Hero can't accelorate while in rolling.
                            Greenfoot.playSound("Roll.wav");
                        }
                        setImage("SonicJumpLeft0.png");
                        //This makes the Hero roll if he's at a certian speed.
                   }  
                   if(rolling == true)
                   {
                        //
                   }
                   if (rolling == false)
                   {
                        if(Greenfoot.isKeyDown("right") && xSpeed < -4.0)
                        {
                            Greenfoot.playSound("Skid.wav");
                            setImage("SonicQuickRight1.png");
                        }
                        if(Greenfoot.isKeyDown("left") && xSpeed > 4.0)
                        {
                            Greenfoot.playSound("Skid.wav");
                            setImage("SonicQuickLeft1.png");
                        }
                        if(lookRight == false)
                        {
                             if ((xSpeed < -0.1) && (xSpeed > -4 ))
                                setImage("SonicWalkLeft4.png");
                             if ((xSpeed < -4.0) && (xSpeed > -6.8))
                                setImage("SonicRunLeft2.png");
                             if(xSpeed < -6.8)
                                setImage("SonicTopSpeedLeft1.png");
                        }
                        if(lookRight == true)
                        {
                             if ((xSpeed > 0.1) && (xSpeed < 4))
                                setImage("SonicWalk4.png");
                             if ((xSpeed > 4.0) && (xSpeed < 6.8))
                                setImage("SonicRun2.png");
                             if(xSpeed > 6.8)
                                setImage("SonicTopSpeed1.png");
                        }
                   }
               }
               if(offGround == true)
               {
                   if (lookRight == true)
                       setImage("SonicJump0.png");
                    else
                        setImage("SonicJumpLeft0.png");
               }
            }
            if ((spring !=null))
            {
                //This says that, if Hero colides with the object Red Spring
                //at any given time, Hero will be shot upwards!
                offGround = true;
                ySpeed = -9.5; //This is what gives the spring it's sprung.
                power = 0.15; //Gives Hero a little extra 'Ooomph' when jumping or launching off a spring.
                rolling = false;
                spikeHit = false;
                springLaunch = true;
                rotation = 0;
                if(lookRight == false)
                    setImage("SonicSpringLeft1.png");
                if(lookRight == true)
                    setImage("SonicSpring1.png"); //Makes Hero turn into the flying animation.
                Greenfoot.playSound("Spring.wav"); //"Realistic" Spring sound effect!
            }
            if ((wallDetect != null) && (xSpeed > 0.1) || (springRight != null) || (ringMonitorRight != null && rolling == false))
            {
                //Tries to prevent Hero from phasing through walls.
               xSpeed = xSpeed - xSpeed;
               offGround = false;
            }
            if(lookRight == false || xSpeed < -0.1)
            if((wallDetectRightWall != null) || springLeft != null || ringMonitorLeft != null && rolling == false)
            {
                //Tries to prevent Hero from phasing through walls.
                xSpeed = xSpeed + -xSpeed + 0.07;
                offGround = false;
            }
            Actor ceilingDetect = getOneIntersectingObject(CeilingDetect.class);
            Actor leftPlatCornerDetect1 = getOneObjectAtOffset(-16, -16, LeftPlatCornerDetect.class);
            Actor leftPlatCornerDetect2 = getOneObjectAtOffset(16, 16, LeftPlatCornerDetect.class);
            Actor rightPlatCornerDetect1 = getOneObjectAtOffset(-16, 16, RightPlatCornerDetect.class);
            Actor rightPlatCornerDetect2 = getOneObjectAtOffset(16, -16, RightPlatCornerDetect.class);
            if (ceilingDetect != null)
            {
                //Tries to keep Hero from jumping through a platform or ceiling... o_o
                ySpeed = 6;
                //ySpeed = -ySpeed + 0.4;
                offGround = false;
                spikeHit = false;
            }
            if (leftPlatCornerDetect1 != null || leftPlatCornerDetect2 != null || rightPlatCornerDetect1 != null || rightPlatCornerDetect2 != null)
            {
                ySpeed = 6;
                offGround = false;
            }
            Actor spikeDetect = getOneIntersectingObject(SpikesDetect.class);
            if ((spikeDetect != null))
            {
                if(count > 0)
                {
                    //Makes the Hero get hurt if he touches a spike with Rings.
                    ySpeed = -3.5; 
                    rotation = 0;
                    if(lookRight == true)
                    {
                        xSpeed = -3.5; //Sends Hero in the opposite direction of where he came.
                        setImage("SonicHurt0.png");
                    }
                    if(lookRight == false)
                    {
                        xSpeed = 3.5;
                        setImage("SonicHurtLeft0.png");
                    }
                    Greenfoot.playSound("RingLoss.wav");    
                    myLabel.setText("0"); //Set's the value of the Rings label back to 0.
                    offGround = true;
                    rolling = true;
                    spikeHit = true; //To make sure you won't accedently collide with the sprikes twise, one step from another.
                    count = 0; //Set's the actual variable Rings to 0.
                }
                if(count == 0 && spikeHit == false)
                {
                    //If Hero hits the spikes with no rings, well..... See ya.
                    ySpeed = -7;    //Give him his speed before, otherwise he'll continue to go -7y!
                    rotation = 0;
                    Greenfoot.playSound("Die.wav");
                    alive = false;  //Starts the death sequence.
                }
            }
            Actor crabmeat = getOneIntersectingObject(Crabmeat.class);
            if (crabmeat !=  null || ringMonitor != null)
            {
                //If you are just strolling along and aren't paying attention to where your going right, and you happen by a
                //Crabmeat, than your gonna get hurt.
                if((offGround == false) && (rolling == false))
                {
                    if(spikeHit == false && crabmeat !=null)
                    {
                        if(count == 0)
                        {
                            ySpeed = -7;
                            Greenfoot.playSound("Die.wav");
                            alive = false;
                        }
                        if(count > 0)
                        {
                            ySpeed = -3.5;
                            if(lookRight == true)
                            {
                                xSpeed = -3.5; //Sends Hero in the opposite direction of where he came.
                                setImage("SonicHurt0.png");
                            }
                            else
                            {
                                xSpeed = 3.5;
                                setImage("SonicHurtLeft0.png");
                            }
                            Greenfoot.playSound("RingLoss.wav");
                            myLabel.setText("0"); //Set's the value of the Rings label back to 0.
                            offGround = true;
                            rolling = true;
                            spikeHit = true; //To make sure you won't accedently collide with the sprikes twise, one step from another.
                            count = 0; //Set's the actual variable Rings to 0.
                        }
                    }
                }
                if((rolling == true) || (offGround == true))
                {
                    if(crabmeat != null)
                    {
                        getWorld().removeObject(crabmeat);
                        score = score + 100;
                        hudScore.setText("" + score);
                    }
                    if(ringMonitor != null)
                    {
                        count = count + 10;
                        myLabel.setText("" + count);
                        Greenfoot.playSound("Ring.wav");
                        getWorld().removeObject(ringMonitor);
                    }
                    Greenfoot.playSound("Destroyed.wav");
                    if(rolling == false && offGround == true)
                        ySpeed = -ySpeed;
                }
            }
            if (Greenfoot.isKeyDown("left") && (rolling == false) && (wallDetectRightWall == null) && (xSpeed >= -maxSpeed))
            {
                xSpeed = xSpeed - power;
                lookRight = false;
                //Increases or decreases the speed the Hero is going, based on
                //wether the key is being pressed or not and if Hero is rolling or not.
                //*applies to the following command.
            }
            if (Greenfoot.isKeyDown("right")  && (rolling == false) && (wallDetect == null) && (xSpeed <= maxSpeed))
            {
               xSpeed = xSpeed + power;
               lookRight = true;
            }
            if (xSpeed > 0.07)
            {
                xSpeed = xSpeed - slowdown;
                //This insures that the decceleration won't make you go the
                //opposite direction. 
                //*Same as the following command.
            } 
            else if (xSpeed < 0)
            {
                xSpeed = xSpeed += slowdown;
            }
        //After everything else is considered, the game will change 
        //these instances.
        ySpeed = ySpeed + gravity;  //Adds gravity to the equasion.
        x = getX() + xSpeed; //Sets his left or right movement values.
        y = getY() + ySpeed; //Sets his up and down movement values.
        setLocation ((int)x, (int)y);   //Sets the Hero's location based on the privious commands.
        if(Greenfoot.isKeyDown("s") && debug == true)
        {
            System.out.println("xSpeed: " + xSpeed + "      ySpeed:" + ySpeed);
            System.out.println("x: " + x + "           y: " + y); 
        }
        if (offGround == true && springLaunch == false && spikeHit == false)
        {
            if (lookRight == true)
                setRotation(getRotation() + 18);
            if (lookRight == false)
                setRotation(getRotation() - 18);
        }
        else
        {
            setRotation(0);
        }
        gatherRing();
    } 
    else 
    {
        die();
    }
    HeroWorld wrld = (HeroWorld)getWorld();
    if(x > 1023)
    {
        wrld.roomChangeUp();
        setLocation (2, (int)y);
        if (debug == true)
            System.out.println("User went forward 1 screen!");
    }
    if(x < 1)
    {
        wrld.roomChangeDown();
        setLocation (1022, (int)y);
        if (debug == true)
            System.out.println("User went back 1 Screen!");
    }
    if(y > 639)
    {
        die();
    }
}
        public int getScore()
        {
            return score;
        }
        public void increaseScore()
        {
            score = score + 10;
        }
            public boolean foundRing()
        {
            Ring ringUp = (Ring)getOneObjectAtOffset(0, -12, Ring.class);
            Ring ringRight = (Ring)getOneObjectAtOffset(12, 0, Ring.class);
            Ring ringDown = (Ring)getOneObjectAtOffset(0, 12, Ring.class);
            Ring ringLeft = (Ring)getOneObjectAtOffset(-12, 0, Ring.class);
            Actor ring = getOneObjectAtOffset(0, 0, Ring.class);
            if(ringUp != null || ringRight != null || ringDown != null || ringLeft != null) 
                return true;
            else 
                return false;
        }
    
    public void gatherRing()
    {
        Ring ring = (Ring)getOneIntersectingObject(Ring.class);
        if(ring != null) 
        {
            count++;
            myLabel.setText("" + count);
            Greenfoot.playSound("Ring.wav");
            ring.setImage();
            Greenfoot.delay(10);
            getWorld().removeObject(ring);
        }
    }
    
    public void die()
    {
         HeroWorld wrld = (HeroWorld)getWorld();  //Calls HeroWorld so that it can stop the music and remove itself.
         wrld.stopped();    //Calls the command stopped from Heroworld.
         setImage("SonicDie.png");
         xSpeed = 0;
        //This stuff is still required if I want him to do his unique fall.
        ySpeed = ySpeed + gravity;  //Adds gravity to the equasion.
        double x = getX() + xSpeed; //Sets his left or right movement values.
        double y = getY() + ySpeed; //Sets his up and down movement values.
        setLocation ((int)x, (int)y);   //Sets the Hero's location based on the privious commands.
        if (y > 638)
        {
            //Once he hits the bottom of the screen, dellete himself and stop the game.
            getWorld().addObject(new GAMEOVER(), 540, 320);
            Greenfoot.playSound("GameOver.wav");
            getWorld().removeObject(this);
            Greenfoot.delay(500);
            Greenfoot.stop();
        }
    }
}
