import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class HeroWorld here.
 * 
 * @author Sam Been 
 * @version Build 1.30
 */
public class HeroWorld  extends World
{
    GreenfootSound song = new GreenfootSound("PalmtreePanic.mp3"); 
    /**
     * Constructor for objects of class HeroWorld.
     * 
     */
    private int drawRoom = 0;
    private int drawRoomMax = 6;
    private boolean done = false;
    
    public HeroWorld()
    {    
        super(1024, 640, 1); // Creates a new world with 1080x640 cells with a cell size of 1x1 pixels.
        
        //Platform Base (Row 0)
            //Stage Objects
            addObject(new Flower00(), 480, 558);
            addObject(new Flower00(), 640, 558);
            addObject(new Flower00(), 960, 558);
            addObject(new Grass01(), 0, 550);
            addObject(new Grass01(), 64, 550);
            addObject(new Palmtree01(), 92, 500);
            addObject(new Grass01(), 128, 550);
            addObject(new Grass01(), 192, 550);
            addObject(new Palmtree01(), 384, 520);
            addObject(new Grass01(), 256, 550);
            addObject(new Grass01(), 320, 550);
            //addObject(new Grass01(), 384, 550);
            //addObject(new Grass01(), 448, 550);
            addObject(new Grass01(), 512, 550);
            addObject(new Grass01(), 576, 550);
            addObject(new Grass01(), 640, 550);
            addObject(new Grass01(), 704, 550);
            addObject(new Grass01(), 768, 550);
            addObject(new Grass01(), 832, 550);
            addObject(new Grass01(), 896, 550);
        //Platforms
            addObject(new Platform01(), 0, 612);
            addObject(new Platform01(), 64, 612);
            addObject(new Platform01(), 128, 612);
            addObject(new Platform01(), 192, 612);
            addObject(new Platform01(), 256, 612);
            addObject(new Platform01(), 320, 612);
            addObject(new Platform01(), 384, 612);
            addObject(new Platform01(), 448, 612);
            addObject(new Platform01(), 512, 612);
            addObject(new Platform01(), 576, 612);
            addObject(new Platform01(), 640, 612);
            addObject(new Platform01(), 704, 612);
            addObject(new Platform01(), 768, 612);
            addObject(new Platform01(), 832, 612);
            addObject(new Platform01(), 896, 612);
            addObject(new Platform01(), 960, 612);
            addObject(new Platform01(), 1024, 612);
            addObject(new Platform01(), 1088, 612);
       //Ground Tiles
            addObject(new Ground(), 0, 612);
            addObject(new Ground(), 64, 612);
            addObject(new Ground(), 128, 612);
            addObject(new Ground(), 192, 612);
            addObject(new Ground(), 256, 612);
            addObject(new Ground(), 320, 612);
            addObject(new Ground(), 384, 612);
            addObject(new Ground(), 448, 612);
            addObject(new Ground(), 512, 612);
            addObject(new Ground(), 576, 612);
            addObject(new Ground(), 640, 612);
            addObject(new Ground(), 704, 612);
            addObject(new Ground(), 768, 612);
            addObject(new Ground(), 832, 612);
            addObject(new Ground(), 896, 612);
            addObject(new Ground(), 960, 612);
            addObject(new Ground(), 1024, 612);
            addObject(new Ground(), 1088, 612);
    
       //Essentials! DO NOT REMOVE
       //Doing so could cause initialization falure!
       Label label = new Label("0");
       HUDscore hudScore = new HUDscore("0");
       addObject(new HUD(), 64, 32);
       addObject(label, 88, 48);
       addObject(hudScore, 88, 16);
       addObject(new MinDisplay("0"), 72, 32);
       addObject(new SecDisplay("0"), 92, 32);
       addObject(new MilisecDisplay("00"), 132, 32); 
       addObject(new Hero(label, hudScore), 160, 550);
       //addObject(new Background(), 512, 320);
       //addObject(new Logo(), 512, 320);
       //addObject(new NewGameButton(), 512, 480);
       addObject(new GameNotice(), 512, 320);
       
       Greenfoot.start();
    }
    public void stopped()
    {
        song.stop(); //Makes sure the Midi music stops when the game is paused or ended.
    }
    public void started()
    {
        song.playLoop(); //Plays the Midi music again should the player press the play button again.
    }
    public void drawRooms()
    {    
        
        /**
        * Programmers Guide to the ground tiles!
        *  The ground tiles are numorus and it can be very nausiating
        *  remembering what ground # stands for what! This guide will
        *  help you in case you lose your mind.
        *  
        *  Ground is the default. It's a flat, grass covered plane.
        *  all grounds afterwards are numbered with 2 didgets.
        *  02: A Flat, Triangle pattern.
        *  03: Dark on the Left side, for use on left platform edges.
        *  04: Dark on the Right side, for use on Right platform edges.
        *  05: Dark on Left with Grass on top. Meant for Left platform corners.
        *  06: Dark on Right with Grass on top. Meant for Right platform corners.
        *  07: Dark on Bottom. For a floating or petruding platform.
        *  08: Bottom Left corner for Floating or petruding platforms.
        *  09: Bottom Right corner for floating or petruding platforms.
        */

        //---------NOTES:-------
        //- Platforms are 64x64 and layed out in a grid.
        //- The rows start from the bottom and go up,
        //and are numbered 0 (the Base) to 10 (Ceiling).
        //- Stage objects like the Flower may overlap
        //previous rows, so it must be placed before the ground
        //That you're placing it on.
        
        //Tile Locations
        //This is a refference for where tiles are to generally
        //be placed in the room. each one starts from 0, 0 and goes up.
        //Starts at Row 1 and goes up.
        //   X,   Y 
        //   0,   0
        //  64,  46
        //  92, 100
        // 128, 164
        // 192, 228
        // 256, 292
        // 320, 356
        // 384, 420
        // 448, 484
        // 512, 548
        // 576
        // 640
        // 704
        // 768
        // 832
        // 896
        // 960
        //1024
        //1088
        
        //Gathering Objects
        List grass = getObjects(Grass01.class);
        List flower0 = getObjects(Flower00.class);
        List flower1 = getObjects(Flower02.class);
        List tree = getObjects(Palmtree01.class);
        List spring1 = getObjects(Spring01.class);
        List ring = getObjects(Ring.class);
        List ringMonitor = getObjects(RingMonitor.class);
        List crab = getObjects(Crabmeat.class);
        List enemyLeft = getObjects(BadnikDetectGoLeft.class);
        List enemyRight = getObjects(BadnikDetectGoRight.class);
        List spikes = getObjects(Spikes01.class);
        List platform1 = getObjects(Platform01.class);
        List ground01 = getObjects(Ground.class);
        List ground02 = getObjects(Ground02.class);
        List ground03 = getObjects(Ground03.class);
        List ground04 = getObjects(Ground04.class);
        List ground05 = getObjects(Ground05.class);
        List ground06 = getObjects(Ground06.class);
        List ground07 = getObjects(Ground07.class);
        List ground08 = getObjects(Ground08.class);
        List ground09 = getObjects(Ground09.class);
        List leftWall = getObjects(WallDetect.class);
        List rightWall = getObjects(WallDetectRightWall.class);
        List ceiling = getObjects(CeilingDetect.class);
        List leftCorner = getObjects(LeftPlatCornerDetect.class);
        List rightCorner = getObjects(RightPlatCornerDetect.class);
        List spikeDetect = getObjects(SpikesDetect.class);
        
        //Remove Objects
        removeObjects(grass);
        removeObjects(flower0);
        removeObjects(flower1);
        removeObjects(tree);
        removeObjects(spring1);
        removeObjects(ring);
        removeObjects(ringMonitor);
        removeObjects(crab);
        removeObjects(enemyLeft);
        removeObjects(enemyRight);
        removeObjects(spikes);
        removeObjects(platform1);
        removeObjects(ground01);
        removeObjects(ground02);
        removeObjects(ground03);
        removeObjects(ground04);
        removeObjects(ground05);
        removeObjects(ground06);
        removeObjects(ground07);
        removeObjects(ground08);
        removeObjects(ground09);
        removeObjects(leftWall);
        removeObjects(rightWall);
        removeObjects(ceiling);
        removeObjects(leftCorner);
        removeObjects(rightCorner);
        removeObjects(spikeDetect);
        
        if(drawRoom == 0)
        {
             //Platform Base (Row 0)
            //Stage Objects
            addObject(new Flower00(), 480, 558);
            addObject(new Flower00(), 640, 558);
            addObject(new Flower00(), 960, 558);
            addObject(new Grass01(), 0, 550);
            addObject(new Grass01(), 64, 550);
            addObject(new Palmtree01(), 92, 500);
            addObject(new Grass01(), 128, 550);
            addObject(new Grass01(), 192, 550);
            addObject(new Palmtree01(), 384, 520);
            addObject(new Grass01(), 256, 550);
            addObject(new Grass01(), 320, 550);
            addObject(new Grass01(), 512, 550);
            addObject(new Grass01(), 576, 550);
            addObject(new Grass01(), 640, 550);
            addObject(new Grass01(), 704, 550);
            addObject(new Grass01(), 768, 550);
            addObject(new Grass01(), 832, 550);
            addObject(new Grass01(), 896, 550);
            //Platforms
            addObject(new Platform01(), 0, 612);
            addObject(new Platform01(), 64, 612);
            addObject(new Platform01(), 128, 612);
            addObject(new Platform01(), 192, 612);
            addObject(new Platform01(), 256, 612);
            addObject(new Platform01(), 320, 612);
            addObject(new Platform01(), 384, 612);
            addObject(new Platform01(), 448, 612);
            addObject(new Platform01(), 512, 612);
            addObject(new Platform01(), 576, 612);
            addObject(new Platform01(), 640, 612);
            addObject(new Platform01(), 704, 612);
            addObject(new Platform01(), 768, 612);
            addObject(new Platform01(), 832, 612);
            addObject(new Platform01(), 896, 612);
            addObject(new Platform01(), 960, 612);
            addObject(new Platform01(), 1024, 612);
            addObject(new Platform01(), 1088, 612);
            //Ground Tiles
            addObject(new Ground(), 0, 612);
            addObject(new Ground(), 64, 612);
            addObject(new Ground(), 128, 612);
            addObject(new Ground(), 192, 612);
            addObject(new Ground(), 256, 612);
            addObject(new Ground(), 320, 612);
            addObject(new Ground(), 384, 612);
            addObject(new Ground(), 448, 612);
            addObject(new Ground(), 512, 612);
            addObject(new Ground(), 576, 612);
            addObject(new Ground(), 640, 612);
            addObject(new Ground(), 704, 612);
            addObject(new Ground(), 768, 612);
            addObject(new Ground(), 832, 612);
            addObject(new Ground(), 896, 612);
            addObject(new Ground(), 960, 612);
            addObject(new Ground(), 1024, 612);
            addObject(new Ground(), 1088, 612);
        }
        if(drawRoom == 1)
        {
            //Platform Base (Row 0)
            //Stage Objects
            addObject(new Flower00(), 480, 558);
            addObject(new Grass01(), 0, 550);
            addObject(new Grass01(), 64, 550);
            addObject(new Palmtree01(), 92, 500);
            addObject(new Grass01(), 128, 550);
            addObject(new Grass01(), 192, 550);
            addObject(new Palmtree01(), 256, 520);
            addObject(new Grass01(), 256, 550);
            addObject(new Grass01(), 320, 550);
            addObject(new Grass01(), 384, 550);
            addObject(new Grass01(), 448, 550);
            addObject(new Grass01(), 512, 550);
            addObject(new Grass01(), 576, 550);
            addObject(new Grass01(), 768, 550);
            addObject(new Palmtree01(), 832, 500);
            addObject(new Grass01(), 832, 550);
            addObject(new Grass01(), 896, 550);
            //Platforms
            addObject(new Platform01(), 0, 612);
            addObject(new Platform01(), 64, 612);
            addObject(new Platform01(), 128, 612);
            addObject(new Platform01(), 192, 612);
            addObject(new Platform01(), 256, 612);
            addObject(new Platform01(), 320, 612);
            addObject(new Platform01(), 384, 612);
            addObject(new Platform01(), 448, 612);
            addObject(new Platform01(), 512, 612);
            addObject(new Platform01(), 576, 612);
            addObject(new Platform01(), 768, 612);
            addObject(new Platform01(), 832, 612);
            addObject(new Platform01(), 896, 612);
            addObject(new Platform01(), 960, 612);
            addObject(new Platform01(), 1024, 612);
            addObject(new Platform01(), 1088, 612);
            //Ground Tiles
            addObject(new Ground(), 0, 612);
            addObject(new Ground(), 64, 612);
            addObject(new Ground(), 128, 612);
            addObject(new Ground(), 192, 612);
            addObject(new Ground(), 256, 612);
            addObject(new Ground(), 320, 612);
            addObject(new Ground(), 384, 612);
            addObject(new Ground(), 448, 612);
            addObject(new Ground(), 512, 612);
            addObject(new Ground(), 576, 612);
            addObject(new Ground03(), 640, 612);
            addObject(new Ground04(), 704, 612);
            addObject(new Ground(), 768, 612);
            addObject(new Ground(), 832, 612);
            addObject(new Ground(), 896, 612);
            addObject(new Ground02(), 960, 612);
            addObject(new Ground02(), 1024, 612);
            addObject(new Ground02(), 1088, 612);
     
            //Row 1
            //Stage Objects
            addObject(new Flower02(), 640, 484);
            addObject(new Spikes01(), 832, 564);
            //Detectors
            addObject(new WallDetect(), 606, 550);
            addObject(new WallDetectRightWall(), 737, 550);
            addObject(new WallDetect(), 810, 585);
            addObject(new SpikesDetect(), 832, 564);
            addObject(new WallDetectRightWall(), 852, 585);
            addObject(new WallDetect(), 928, 550);
            //Platforms
            addObject(new Platform01(), 640, 548);
            addObject(new Platform01(), 704, 548);
            //Ground Tiles
            addObject(new Ground05(), 640, 548);
            addObject(new Ground06(), 704, 548);
            addObject(new Ground03(), 960, 548);
            addObject(new Ground02(), 1024, 548);
        
        
            //Row 2
            //Stage Objects
            addObject(new Flower00(), 960, 430);
            addObject(new Ring(), 710, 490);
            addObject(new Ring(), 634, 490);
            //Detectors
            addObject(new WallDetect(), 928, 490);
            addObject(new CeilingDetect(), 384, 484);
            addObject(new LeftPlatCornerDetect(), 320, 484);
            addObject(new RightPlatCornerDetect(), 448, 484);
            //Platforms
            addObject(new Platform01(), 960, 484);
            addObject(new Platform01(), 1024, 484);
            //Ground
            addObject(new Ground08(), 320, 484);
            addObject(new Ground07(), 384, 484);
            addObject(new Ground09(), 448, 484);
            addObject(new Ground05(), 960, 484);
            addObject(new Ground(), 1024, 484);
        
            //Row 3
            //Stage Objects
            addObject(new Flower00(), 320, 366);
            addObject(new Ring(), 960 ,420);
            addObject(new Ring(), 1024 ,420);
            //Detectors
            addObject(new WallDetect(), 287, 422);
            addObject(new WallDetectRightWall(), 482, 422);
            //Platforms
            addObject(new Platform01(), 320, 420);
            addObject(new Platform01(), 384, 420);
            addObject(new Platform01(), 448, 420);
            //Ground
            addObject(new Ground05(), 320, 420);
            addObject(new Ground(), 384, 420);
            addObject(new Ground06(), 448, 420);
        
            //Row 4
            //Stage Objects
            addObject(new Ring(), 320, 356);
            addObject(new Spring01(), 384, 356);
            addObject(new Ring(), 448, 356);
            //Detectors
            //none
            //Platforms
            //none
            //Ground
            //none
        
            //Row 5
            //Detectors
            addObject(new LeftPlatCornerDetect(), 832, 292);
            addObject(new CeilingDetect(), 896, 292);
            addObject(new CeilingDetect(), 960, 292);
            addObject(new CeilingDetect(), 1024, 292);
            addObject(new CeilingDetect(), 1088, 292);
            //Platforms
            //none
            //Ground
            addObject(new Ground08(), 832, 292);
            addObject(new Ground07(), 896, 292);
            addObject(new Ground07(), 960, 292);
            addObject(new Ground07(), 1024, 292);
        
            //Row 6
            //Detectors
            addObject(new LeftPlatCornerDetect(), 640, 228);
            addObject(new CeilingDetect(), 704, 228);
            addObject(new CeilingDetect(), 768, 228);
            //Platforms
            //none
            //Ground
            addObject(new Ground08(), 640, 228);
            addObject(new Ground07(), 704, 228);
            addObject(new Ground07(), 768, 228);
            addObject(new Ground02(), 832, 228);
            addObject(new Ground02(), 896, 228);
            addObject(new Ground02(), 960, 228);
            addObject(new Ground02(), 1024, 228);
        
            //Row 7
            //Stage Objects
            addObject(new Flower00(), 640, 110);
            addObject(new Flower02(), 704, 100);
            addObject(new Grass01(), 768, 105);
            addObject(new Grass01(), 832, 105);
            addObject(new Grass01(), 896, 105);
            addObject(new Flower02(), 960, 100);
            //Detectors
            addObject(new WallDetect(), 607, 167);
            //Platforms
            addObject(new Platform01(), 640, 164);
            addObject(new Platform01(), 704, 164);
            addObject(new Platform01(), 768, 164);
            addObject(new Platform01(), 832, 164);
            addObject(new Platform01(), 896, 164);
            addObject(new Platform01(), 960, 164);
            addObject(new Platform01(), 1024, 164);
            //Ground
            addObject(new Ground05(), 640, 164);
            addObject(new Ground(), 704, 164);
            addObject(new Ground(), 768, 164);
            addObject(new Ground(), 832, 164);
            addObject(new Ground(), 896, 164);
            addObject(new Ground(), 960, 164);
            addObject(new Ground(), 992, 164);
        
            //Row 8
            //Stage Objects
            addObject(new Ring(), 768, 100);
            addObject(new Ring(), 832, 100);
            addObject(new Ring(), 896, 100);
            addObject(new Crabmeat(), 960, 100);
            //Stage Detectors
            addObject(new BadnikDetectGoRight(), 704, 100);
            addObject(new BadnikDetectGoLeft(), 1024, 100);
            
            //Row 9
            //Stage Objects
            addObject(new Ring(), 768, 46);
            addObject(new Ring(), 832, 46);
            addObject(new Ring(), 896, 46);
        }
        if(drawRoom == 2)
        {
            //Platform Base (Row 0)
            //Platforms
            addObject(new Platform01(), 512, 612);
            addObject(new Platform01(), 576, 612);
            addObject(new Platform01(), 640, 612);
            addObject(new Platform01(), 704, 612);
            addObject(new Platform01(), 768, 612);
            addObject(new Platform01(), 832, 612);
            addObject(new Platform01(), 896, 612);
            addObject(new Platform01(), 960, 612);
            addObject(new Platform01(), 1024, 612);
            addObject(new Platform01(), 1088, 612);
            //Ground Tiles
            addObject(new Ground02(), 0, 612);
            addObject(new Ground02(), 64, 612);
            addObject(new Ground02(), 128, 612);
            addObject(new Ground02(), 192, 612);
            addObject(new Ground02(), 256, 612);
            addObject(new Ground02(), 320, 612);
            addObject(new Ground02(), 384, 612);
            addObject(new Ground02(), 448, 612);
            addObject(new Ground(), 512, 612);
            addObject(new Ground(), 576, 612);
            addObject(new Ground(), 640, 612);
            addObject(new Ground(), 704, 612);
            addObject(new Ground(), 768, 612);
            addObject(new Ground(), 832, 612);
            addObject(new Ground(), 896, 612);
            addObject(new Ground(), 960, 612);
            addObject(new Ground(), 1024, 612);
            addObject(new Ground(), 1088, 612);
            //Stage Objects
            addObject(new Grass01(), 513, 551);
            addObject(new Grass01(), 577, 551);
            addObject(new Grass01(), 773, 551);
            addObject(new Grass01(), 838, 551);
            
            
            //Row 1
            //Detectors
            addObject(new WallDetectRightWall(), 481, 550);
            //Platforms
            addObject(new Platform01(), 448, 548);
            //Ground Tiles
            addObject(new Ground02(), 0, 548);
            addObject(new Ground02(), 64, 548);
            addObject(new Ground02(), 128, 548);
            addObject(new Ground02(), 192, 548);
            addObject(new Ground02(), 256, 548);
            addObject(new Ground02(), 320, 548);
            addObject(new Ground02(), 384, 548);
            addObject(new Ground04(), 448, 548);
            //Stage Objects
            addObject(new Ring(), 704, 548);
            addObject(new Ring(), 768, 548);
            addObject(new Ring(), 832, 548);
            addObject(new Ring(), 896, 548);
            
            //Row 2
            //Detectors
            addObject(new WallDetectRightWall(), 481, 488);
            //Platforms
            addObject(new Platform01(), 0, 484);
            addObject(new Platform01(), 64, 484);
            addObject(new Platform01(), 128, 484);
            addObject(new Platform01(), 192, 484);
            addObject(new Platform01(), 256, 484);
            addObject(new Platform01(), 320, 484);
            addObject(new Platform01(), 384, 484);
            addObject(new Platform01(), 448, 484);
            //Ground Tiles
            addObject(new Ground(), 0, 484);
            addObject(new Ground(), 64, 484);
            addObject(new Ground(), 128, 484);
            addObject(new Ground(), 192, 484);
            addObject(new Ground(), 256, 484);
            addObject(new Ground(), 320, 484);
            addObject(new Ground(), 384, 484);
            addObject(new Ground06(), 448, 484);
            //Stage Objects
            addObject(new Flower02(), 320, 422);
            
            //Row 5
            //Platforms
            addObject(new CeilingDetect(), 0, 292);
            addObject(new CeilingDetect(), 64, 292);
            addObject(new CeilingDetect(), 128, 292);
            addObject(new CeilingDetect(), 192, 292);
            addObject(new CeilingDetect(), 256, 292);
            addObject(new CeilingDetect(), 320, 292);
            addObject(new CeilingDetect(), 384, 292);
            addObject(new RightPlatCornerDetect(), 448, 292);
            addObject(new LeftPlatCornerDetect(), 704, 292);
            addObject(new CeilingDetect(), 768, 292);
            addObject(new CeilingDetect(), 832, 292);
            addObject(new RightPlatCornerDetect(), 896, 292);
            //Ground Tiles
            addObject(new Ground07(), 0, 292);
            addObject(new Ground07(), 64, 292);
            addObject(new Ground07(), 128, 292);
            addObject(new Ground07(), 192, 292);
            addObject(new Ground07(), 256, 292);
            addObject(new Ground07(), 320, 292);
            addObject(new Ground07(), 384, 292);
            addObject(new Ground09(), 448, 292);
            addObject(new Ground08(), 704, 292);
            addObject(new Ground07(), 768, 292);
            addObject(new Ground07(), 832, 292);
            addObject(new Ground09(), 896, 292);
            
            //Row 6
            //Platforms
            addObject(new WallDetectRightWall(), 482, 230);
            addObject(new WallDetect(), 670, 230);
            addObject(new WallDetectRightWall(), 930, 230);
            addObject(new Platform01(), 704, 228);
            addObject(new Platform01(), 768, 228);
            addObject(new Platform01(), 832, 228);
            addObject(new Platform01(), 896, 228);
            //Ground Tiles
            addObject(new Ground02(), 0, 228);
            addObject(new Ground02(), 64, 228);
            addObject(new Ground02(), 128, 228);
            addObject(new Ground02(), 192, 228);
            addObject(new Ground02(), 256, 228);
            addObject(new Ground02(), 320, 228);
            addObject(new Ground02(), 384, 228);
            addObject(new Ground04(), 448, 228);
            addObject(new Ground(), 704, 228);
            addObject(new Ground(), 768, 228);
            addObject(new Ground(), 832, 228);
            addObject(new Ground(), 896, 228);
            //Stage Objects
            addObject(new Flower00(), 881, 168);
            
            //Row 7
            //Platforms
            addObject(new WallDetectRightWall(), 482, 166);
            addObject(new Platform01(), 0, 164);
            addObject(new Platform01(), 64, 164);
            addObject(new Platform01(), 128, 164);
            addObject(new Platform01(), 192, 164);
            addObject(new Platform01(), 256, 164);
            addObject(new Platform01(), 320, 164);
            addObject(new Platform01(), 384, 164);
            addObject(new Platform01(), 448, 164);
            //Ground Tiles
            addObject(new Ground(), 0, 164);
            addObject(new Ground(), 64, 164);
            addObject(new Ground(), 128, 164);
            addObject(new Ground(), 192, 164);
            addObject(new Ground(), 256, 164);
            addObject(new Ground(), 320, 164);
            addObject(new Ground(), 384, 164);
            addObject(new Ground06(), 448, 164);
            //Stage Objects
            addObject(new Flower02(), 192, 102);
            addObject(new Grass01(), 320, 102);
            addObject(new Grass01(), 384, 102);
            addObject(new Ring(), 768, 164);
            addObject(new Ring(), 832, 164);
        }
        if(drawRoom == 3)
        {
            //Platform Base (Row 0)
            //Platforms
            addObject(new Platform01(), 0, 612);
            addObject(new Platform01(), 64, 612);
            addObject(new Platform01(), 128, 612);
            addObject(new Platform01(), 192, 612);
            addObject(new Platform01(), 256, 612);
            addObject(new Platform01(), 320, 612);
            addObject(new Platform01(), 384, 612);
            addObject(new Platform01(), 512, 612);
            addObject(new Platform01(), 576, 612);
            addObject(new Platform01(), 640, 612);
            addObject(new Platform01(), 704, 612);
            addObject(new Platform01(), 768, 612);
            //Ground Tiles
            addObject(new Ground(), 0, 612);
            addObject(new Ground(), 64, 612);
            addObject(new Ground(), 128, 612);
            addObject(new Ground(), 192, 612);
            addObject(new Ground(), 256, 612);
            addObject(new Ground(), 320, 612);
            addObject(new Ground(), 384, 612);
            addObject(new Ground(), 448, 612);
            addObject(new Ground(), 512, 612);
            addObject(new Ground(), 576, 612);
            addObject(new Ground(), 640, 612);
            addObject(new Ground(), 704, 612);
            addObject(new Ground(), 768, 612);
            addObject(new Ground02(), 832, 612);
            addObject(new Ground02(), 896, 612);
            addObject(new Ground02(), 960, 612);
            addObject(new Ground02(), 1024, 612);
            addObject(new Ground02(), 1088, 612);
            //Stage Objects
            addObject(new Grass01(), 195, 551);
            addObject(new Grass01(), 257, 551);
            addObject(new Palmtree01(), 582, 502);
            addObject(new Grass01(), 544, 552);
            addObject(new Grass01(), 608, 552);
            
            //Row 1
            //Detectors
            addObject(new WallDetect(), 800, 550);
            addObject(new BadnikDetectGoLeft(), 704, 548);
            addObject(new BadnikDetectGoRight(), 384, 548);
            //Ground Tiles
            addObject(new Ground03(), 832, 548);
            addObject(new Ground02(), 896, 548);
            addObject(new Ground02(), 960, 548);
            addObject(new Ground02(), 1024, 548);
            addObject(new Ground02(), 1088, 548);
            //Stage Objects
            addObject(new Crabmeat(), 640, 548);
            addObject(new Spring01(), 768, 548);
            //Row 2
            //Detectors
            addObject(new WallDetect(), 800, 486);
            //Ground Tiles
            addObject(new Ground03(), 832, 484);
            addObject(new Ground02(), 896, 484);
            addObject(new Ground02(), 960, 484);
            addObject(new Ground02(), 1024, 484);
            addObject(new Ground02(), 1088, 484);
            //Stage Objects
            addObject(new Ring(), 768, 484);
            //Row 3
            //Detectors
            addObject(new WallDetect(), 800, 422);
            //Ground Tiles
            addObject(new Ground03(), 832, 420);
            addObject(new Ground02(), 896, 420);
            addObject(new Ground02(), 960, 420);
            addObject(new Ground02(), 1024, 420);
            addObject(new Ground02(), 1088, 420);
            //Stage Objects
            addObject(new Ring(), 768, 420);
            
            //Row 4
            //Detectors
            addObject(new WallDetect(), 800, 362);
            addObject(new Platform01(), 832, 356);
            addObject(new Platform01(), 896, 356);
            addObject(new Platform01(), 960, 356);
            addObject(new Platform01(), 1024, 356);
            addObject(new Platform01(), 1088, 356);
            //Ground Tiles
            addObject(new Ground05(), 832, 356);
            addObject(new Ground(), 896, 356);
            addObject(new Ground(), 960, 356);
            addObject(new Ground(), 1024, 356);
            addObject(new Ground(), 1088, 356);
            //Stage Objects
            addObject(new Ring(), 768, 356);
            addObject(new Flower02(), 962, 294);
            
            //Row 5
            //Detectors
            addObject(new LeftPlatCornerDetect(), 192, 292);
            addObject(new CeilingDetect(), 256, 292);
            addObject(new CeilingDetect(), 320, 292);
            addObject(new CeilingDetect(), 384, 292);
            addObject(new CeilingDetect(), 448, 292);
            addObject(new RightPlatCornerDetect(), 512, 292);
            //Ground Tiles
            addObject(new Ground08(), 192, 292);
            addObject(new Ground07(), 256, 292);
            addObject(new Ground07(), 320, 292);
            addObject(new Ground07(), 384, 292);
            addObject(new Ground07(), 448, 292);
            addObject(new Ground09(), 512, 292);
            
            //Row 6
            //Detectors
            addObject(new WallDetect(), 158, 232);
            addObject(new WallDetectRightWall(), 546, 232);
            //Platforms
            addObject(new Platform01(), 192, 228);
            addObject(new Platform01(), 256, 228);
            addObject(new Platform01(), 320, 228);
            addObject(new Platform01(), 384, 228);
            addObject(new Platform01(), 448, 228);
            addObject(new Platform01(), 512, 228);
            //Ground Tiles
            addObject(new Ground05(), 192, 228);
            addObject(new Ground(), 256, 228);
            addObject(new Ground(), 320, 228);
            addObject(new Ground(), 384, 228);
            addObject(new Ground(), 448, 228);
            addObject(new Ground06(), 512, 228);
            //Stage Objects
            addObject(new Palmtree01(), 320, 118);
            addObject(new Grass01(), 512, 168);
        }
        if(drawRoom == 4)
        {
            //Row 0
            //Platforms
            addObject(new Platform01(), 192, 612);
            addObject(new Platform01(), 256, 612);
            addObject(new Platform01(), 320, 612);
            addObject(new Platform01(), 384, 612);
            addObject(new Platform01(), 448, 612);
            addObject(new Platform01(), 512, 612);
            addObject(new Platform01(), 576, 612);
            addObject(new Platform01(), 640, 612);
            addObject(new Platform01(), 704, 612);
            addObject(new Platform01(), 768, 612);
            addObject(new Platform01(), 832, 612);
            addObject(new Platform01(), 896, 612);
            addObject(new Platform01(), 960, 612);
            addObject(new Platform01(), 1024, 612);
            addObject(new Platform01(), 1088, 612);
            //Ground Tiles
            addObject(new Ground02(), 0, 612);
            addObject(new Ground02(), 64, 612);
            addObject(new Ground02(), 128, 612);
            addObject(new Ground(), 192, 612);
            addObject(new Ground(), 256, 612);
            addObject(new Ground(), 320, 612);
            addObject(new Ground(), 384, 612);
            addObject(new Ground(), 448, 612);
            addObject(new Ground(), 512, 612);
            addObject(new Ground(), 576, 612);
            addObject(new Ground(), 640, 612);
            addObject(new Ground(), 704, 612);
            addObject(new Ground(), 768, 612);
            addObject(new Ground(), 832, 612);
            addObject(new Ground(), 896, 612);
            addObject(new Ground(), 960, 612);
            addObject(new Ground(), 1024, 612);
            addObject(new Ground(), 1088, 612);
            
            //Row 1
            //Detectors
            addObject(new WallDetectRightWall(), 164, 548);
            addObject(new RingMonitor(), 234, 564);
            //Ground Tiles
            addObject(new Ground02(), 0, 548);
            addObject(new Ground02(), 64, 548);
            addObject(new Ground04(), 128, 548);
            //Stage Objects
            addObject(new Flower02(), 322, 550);
            addObject(new Spring01(), 576, 548);
            addObject(new Palmtree01(), 647, 502);
            addObject(new Grass01(), 832, 552);
            addObject(new Grass01(), 896, 552);
            
            //Row 2
            //Detectors
            addObject(new WallDetectRightWall(), 164, 484);
            //Ground Tiles
            addObject(new Ground02(), 0, 484);
            addObject(new Ground02(), 64, 484);
            addObject(new Ground04(), 128, 484);
            
            //Row 3
            //Detectors
            addObject(new CeilingDetect(), 192, 420);
            addObject(new CeilingDetect(), 256, 420);
            addObject(new CeilingDetect(), 320, 420);
            addObject(new CeilingDetect(), 384, 420);
            addObject(new RightPlatCornerDetect(), 448, 420);
            addObject(new LeftPlatCornerDetect(), 704, 420);
            addObject(new CeilingDetect(), 768, 420);
            addObject(new CeilingDetect(), 832, 420);
            addObject(new CeilingDetect(), 896, 420);
            addObject(new CeilingDetect(), 960, 420);
            addObject(new CeilingDetect(), 1024, 420);
            addObject(new CeilingDetect(), 1088, 420);
            //Ground Tiles
            addObject(new Ground02(), 0, 420);
            addObject(new Ground02(), 64, 420);
            addObject(new Ground02(), 128, 420);
            addObject(new Ground07(), 192, 420);
            addObject(new Ground07(), 256, 420);
            addObject(new Ground07(), 320, 420);
            addObject(new Ground07(), 384, 420);
            addObject(new Ground09(), 448, 420);
            addObject(new Ground08(), 704, 420);
            addObject(new Ground07(), 768, 420);
            addObject(new Ground07(), 832, 420);
            addObject(new Ground07(), 896, 420);
            addObject(new Ground07(), 960, 420);
            addObject(new Ground07(), 1024, 420);
            addObject(new Ground07(), 1088, 420);
            
            //Row 4
            //Platforms

            addObject(new Platform01(), 0, 356);
            addObject(new Platform01(), 64, 356);
            addObject(new Platform01(), 128, 356);
            addObject(new Platform01(), 192, 356);
            addObject(new Platform01(), 256, 356);
            addObject(new Platform01(), 320, 356);
            addObject(new Platform01(), 384, 356);
            addObject(new Platform01(), 448, 356);
            addObject(new WallDetectRightWall(), 482, 360);
            addObject(new WallDetect(), 670, 360);
            addObject(new Platform01(), 704, 356);
            addObject(new Platform01(), 768, 356);
            addObject(new Platform01(), 832, 356);
            addObject(new Platform01(), 896, 356);
            addObject(new Platform01(), 960, 356);
            addObject(new Platform01(), 1024, 356);
            addObject(new Platform01(), 1088, 356);
            //Ground Tiles
            addObject(new Ground(), 0, 356);
            addObject(new Ground(), 64, 356);
            addObject(new Ground(), 128, 356);
            addObject(new Ground(), 192, 356);
            addObject(new Ground(), 256, 356);
            addObject(new Ground(), 320, 356);
            addObject(new Ground(), 384, 356);
            addObject(new Ground06(), 448, 356);
            addObject(new Ground05(), 704, 356);
            addObject(new Ground(), 768, 356);
            addObject(new Ground(), 832, 356);
            addObject(new Ground(), 896, 356);
            addObject(new Ground(), 960, 356);
            addObject(new Ground(), 1024, 356);
            addObject(new Ground(), 1088, 356);
            
            //Stage Objects
            addObject(new Grass01(), 128, 297);
            addObject(new Grass01(), 896, 297);
            
            //Row 6
            //Stage Objects
            addObject(new Ring(), 448, 228);
            addObject(new Ring(), 512, 228);
            addObject(new Ring(), 576, 228);
            addObject(new Ring(), 640, 228);
            addObject(new Ring(), 704, 228);
        }
        if(drawRoom == 5)
        {
            //Row 0
            //Detectors
            addObject(new WallDetect(), 484, 615);
            addObject(new WallDetect(), 606, 615);
            //Platforms
            addObject(new Platform01(), 0, 612);
            addObject(new Platform01(), 64, 612);
            addObject(new Platform01(), 128, 612);
            addObject(new Platform01(), 192, 612);
            addObject(new Platform01(), 256, 612);
            addObject(new Platform01(), 320, 612);
            addObject(new Platform01(), 384, 612);
            addObject(new Platform01(), 448, 612);
            addObject(new Platform01(), 640, 612);
            addObject(new Platform01(), 704, 612);
            addObject(new Platform01(), 768, 612);
            addObject(new Platform01(), 832, 612);
            addObject(new Platform01(), 896, 612);
            addObject(new Platform01(), 960, 612);
            addObject(new Platform01(), 1024, 612);
            addObject(new Platform01(), 1088, 612);
            //Ground Tiles
            addObject(new Ground(), 0, 612);
            addObject(new Ground(), 64, 612);
            addObject(new Ground(), 128, 612);
            addObject(new Ground(), 192, 612);
            addObject(new Ground(), 256, 612);
            addObject(new Ground(), 320, 612);
            addObject(new Ground(), 384, 612);
            addObject(new Ground06(), 448, 612);
            addObject(new Ground05(), 640, 612);
            addObject(new Ground(), 704, 612);
            addObject(new Ground(), 768, 612);
            addObject(new Ground(), 832, 612);
            addObject(new Ground(), 896, 612);
            addObject(new Ground(), 960, 612);
            addObject(new Ground(), 1024, 612);
            addObject(new Ground(), 1088, 612);
            //Stage Objects
            addObject(new Grass01(), 320, 552);
            addObject(new Grass01(), 384, 552);
            addObject(new Flower00(), 704, 552);
            addObject(new Grass01(), 768, 552);
            addObject(new Grass01(), 832, 552);
            
            //Row 2
            addObject(new Ring(), 448, 484);
            addObject(new Ring(), 512, 484);
            addObject(new Ring(), 576, 484);
            addObject(new Ring(), 640, 484);
            
            //Row 3
            //Detectors
            addObject(new CeilingDetect(), 0, 420);
            addObject(new CeilingDetect(), 64, 420);
            addObject(new CeilingDetect(), 128, 420);
            addObject(new CeilingDetect(), 192, 420);
            addObject(new CeilingDetect(), 256, 420);
            addObject(new RightPlatCornerDetect(), 320, 420);
            addObject(new LeftPlatCornerDetect(), 768, 420);
            addObject(new CeilingDetect(), 832, 420);
            addObject(new CeilingDetect(), 896, 420);
            addObject(new CeilingDetect(), 960, 420);
            addObject(new CeilingDetect(), 1024, 420);
            addObject(new CeilingDetect(), 1088, 420);
            //Ground Tiles
            addObject(new Ground07(), 0, 420);
            addObject(new Ground07(), 64, 420);
            addObject(new Ground07(), 128, 420);
            addObject(new Ground07(), 192, 420);
            addObject(new Ground07(), 256, 420);
            addObject(new Ground09(), 320, 420);
            addObject(new Ground08(), 768, 420);
            addObject(new Ground07(), 832, 420);
            addObject(new Ground07(), 896, 420);
            addObject(new Ground07(), 960, 420);
            addObject(new Ground07(), 1024, 420);
            addObject(new Ground07(), 1088, 420);
            
            //Row 4
            //Detectors
            addObject(new CeilingDetect(), 384, 356);
            addObject(new CeilingDetect(), 448, 356);
            addObject(new CeilingDetect(), 512, 356);
            addObject(new CeilingDetect(), 576, 356);
            addObject(new CeilingDetect(), 640, 356);
            addObject(new CeilingDetect(), 704, 356);
            //Platforms
            addObject(new Platform01(), 0, 356);
            addObject(new Platform01(), 64, 356);
            addObject(new Platform01(), 128, 356);
            addObject(new Platform01(), 192, 356);
            addObject(new Platform01(), 256, 356);
            //Ground Tiles
            addObject(new Ground(), 0, 356);
            addObject(new Ground(), 64, 356);
            addObject(new Ground(), 128, 356);
            addObject(new Ground(), 192, 356);
            addObject(new Ground(), 256, 356);
            addObject(new Ground02(), 320, 356);
            addObject(new Ground07(), 384, 356);
            addObject(new Ground07(), 448, 356);
            addObject(new Ground07(), 512, 356);
            addObject(new Ground07(), 576, 356);
            addObject(new Ground07(), 640, 356);
            addObject(new Ground07(), 704, 356);
            addObject(new Ground02(), 768, 356);
            addObject(new Ground02(), 832, 356);
            addObject(new Ground02(), 896, 356);
            addObject(new Ground02(), 960, 356);
            addObject(new Ground02(), 1024, 356);
            addObject(new Ground02(), 1088, 356);
            
            //Row 5
            //Platforms
            addObject(new WallDetect(), 286, 295);
            addObject(new Platform01(), 320, 292);
            addObject(new Platform01(), 384, 292);
            addObject(new Platform01(), 448, 292);
            addObject(new Platform01(), 512, 292);
            addObject(new Platform01(), 832, 292);
            addObject(new Platform01(), 896, 292);
            //Ground Tiles
            addObject(new Ground05(), 320, 292);
            addObject(new Ground(), 384, 292);
            addObject(new Ground(), 448, 292);
            addObject(new Ground(), 512, 292);
            addObject(new Ground02(), 576, 292);
            addObject(new Ground02(), 640, 292);
            addObject(new Ground02(), 704, 292);
            addObject(new Ground02(), 768, 292);
            addObject(new Ground(), 832, 292);
            addObject(new Ground(), 896, 292);
            addObject(new Ground02(), 960, 292);
            addObject(new Ground02(), 1024, 292);
            addObject(new Ground02(), 1088, 292);
            
            //Row 6
            //Detectors
            addObject(new WallDetect(), 542, 234);
            addObject(new WallDetectRightWall(), 802, 234);
            addObject(new WallDetect(), 814, 269);
            addObject(new WallDetectRightWall(), 851, 269);
            addObject(new WallDetect(), 927, 233);
            addObject(new SpikesDetect(), 832, 245);
            //Platforms
            addObject(new Platform01(), 576, 228);
            addObject(new Platform01(), 640, 228);
            addObject(new Platform01(), 704, 228);
            addObject(new Platform01(), 768, 228);
            addObject(new Platform01(), 960, 228);
            addObject(new Platform01(), 1024, 228);
            addObject(new Platform01(), 1088, 228);
            //Ground Tiles
            addObject(new Ground05(), 576, 228);
            addObject(new Ground(), 640, 228);
            addObject(new Ground(), 704, 228);
            addObject(new Ground06(), 768, 228);
            addObject(new Ground05(), 960, 228);
            addObject(new Ground(), 1024, 228);
            addObject(new Ground(), 1088, 228);
            //Stage Objects
            addObject(new Spikes01(), 832, 245);
        }
        if(drawRoom == 6)
        {
            //Row 0
            //Platforms
            addObject(new Platform01(), 0, 612);
            addObject(new Platform01(), 64, 612);
            addObject(new Platform01(), 128, 612);
            addObject(new Platform01(), 192, 612);
            addObject(new Platform01(), 256, 612);
            addObject(new Platform01(), 320, 612);
            addObject(new Platform01(), 384, 612);
            addObject(new Platform01(), 448, 612);
            addObject(new Platform01(), 512, 612);
            addObject(new Platform01(), 576, 612);
            addObject(new Platform01(), 640, 612);
            addObject(new Platform01(), 704, 612);
            addObject(new Platform01(), 768, 612);
            addObject(new Platform01(), 832, 612);
            //Ground Tiles
            addObject(new Ground(), 0, 612);
            addObject(new Ground(), 64, 612);
            addObject(new Ground(), 128, 612);
            addObject(new Ground(), 192, 612);
            addObject(new Ground(), 256, 612);
            addObject(new Ground(), 320, 612);
            addObject(new Ground(), 384, 612);
            addObject(new Ground(), 448, 612);
            addObject(new Ground(), 512, 612);
            addObject(new Ground(), 576, 612);
            addObject(new Ground(), 640, 612);
            addObject(new Ground(), 704, 612);
            addObject(new Ground(), 768, 612);
            addObject(new Ground(), 832, 612);
            addObject(new Ground02(), 896, 612);
            addObject(new Ground02(), 960, 612);
            addObject(new Ground02(), 1024, 612);
            addObject(new Ground02(), 1088, 612);
            //Stage Objects
            addObject(new Grass01(), 256, 553);
            addObject(new Grass01(), 384, 553);
            addObject(new Flower02(), 768, 550);
            //Row 1
            //Detectors
            addObject(new WallDetect(), 862, 548);
            //Ground Tiles
            addObject(new Ground03(), 896, 548);
            addObject(new Ground02(), 960, 548);
            addObject(new Ground02(), 1024, 548);
            addObject(new Ground02(), 1088, 548);
            //Stage Objects
            addObject(new Spring01(), 704, 548);
            
            //Row 2
            //Detectors
            addObject(new LeftPlatCornerDetect(), 384, 484);
            addObject(new CeilingDetect(), 448, 484);
            addObject(new CeilingDetect(), 512, 484);
            addObject(new RightPlatCornerDetect(), 576, 484);
            addObject(new WallDetect(), 862, 484);
            //Ground Tiles
            addObject(new Ground08(), 384, 484);
            addObject(new Ground07(), 448, 484);
            addObject(new Ground07(), 512, 484);;
            addObject(new Ground09(), 576, 484);
            addObject(new Ground03(), 896, 484);
            addObject(new Ground02(), 960, 484);
            addObject(new Ground02(), 1024, 484);
            addObject(new Ground02(), 1088, 484);
            
            
            //Row 3
            //Detectors
            addObject(new CeilingDetect(), 0, 420);
            addObject(new CeilingDetect(), 64, 420);
            addObject(new CeilingDetect(), 128, 420);
            addObject(new CeilingDetect(), 192, 420);
            addObject(new CeilingDetect(), 256, 420);
            addObject(new CeilingDetect(), 320, 420);
            addObject(new WallDetectRightWall(), 610, 424);
            addObject(new LeftPlatCornerDetect(), 832, 420);
            //Platforms
            addObject(new Platform01(), 448, 420);
            addObject(new Platform01(), 512, 420);
            addObject(new Platform01(), 576, 420);
            //Ground Tiles
            addObject(new Ground07(), 0, 420);
            addObject(new Ground07(), 64, 420);
            addObject(new Ground07(), 128, 420);
            addObject(new Ground07(), 192, 420);
            addObject(new Ground07(), 256, 420);
            addObject(new Ground07(), 320, 420);
            addObject(new Ground02(), 384, 420);
            addObject(new Ground(), 448, 420);
            addObject(new Ground(), 512, 420);
            addObject(new Ground06(), 576, 420);
            addObject(new Ground08(), 832, 420);
            addObject(new Ground02(), 896, 420);
            addObject(new Ground02(), 960, 420);
            addObject(new Ground02(), 1024, 420);
            addObject(new Ground02(), 1088, 420);
            //Stage objects
            addObject(new Flower00(), 576, 359);
            
            //Row 4
            //Detectors
            addObject(new WallDetectRightWall(), 418, 356);
            addObject(new LeftPlatCornerDetect(), 768, 356);
            //Ground Tiles
            addObject(new Ground02(), 0, 356);
            addObject(new Ground02(), 64, 356);
            addObject(new Ground02(), 128, 356);
            addObject(new Ground02(), 192, 356);
            addObject(new Ground02(), 256, 356);
            addObject(new Ground02(), 320, 356);
            addObject(new Ground04(), 384, 356);
            addObject(new Ground08(), 768, 356);
            addObject(new Ground02(), 832, 356);
            addObject(new Ground02(), 896, 356);
            addObject(new Ground02(), 960, 356);
            addObject(new Ground02(), 1024, 356);
            addObject(new Ground02(), 1088, 356);
            //Stage Objects
            addObject(new RingMonitor(), 447, 372);
            
            //Row 5
            //Detectors
            addObject(new CeilingDetect(), 448, 292);
            addObject(new RightPlatCornerDetect(), 512, 292);
            addObject(new WallDetect(), 736, 296);
            //Platforms
            addObject(new Platform01(), 768, 292);
            addObject(new Platform01(), 832, 292);
            //Ground Tiles
            addObject(new Ground02(), 0, 292);
            addObject(new Ground02(), 64, 292);
            addObject(new Ground02(), 128, 292);
            addObject(new Ground02(), 192, 292);
            addObject(new Ground02(), 256, 292);
            addObject(new Ground02(), 320, 292);
            addObject(new Ground02(), 384, 292);
            addObject(new Ground07(), 448, 292);
            addObject(new Ground09(), 512, 292);
            addObject(new Ground05(), 768, 292);
            addObject(new Ground(), 832, 292);
            addObject(new Ground02(), 896, 292);
            addObject(new Ground02(), 960, 292);
            addObject(new Ground02(), 1024, 292);
            addObject(new Ground02(), 1088, 292);
            //Stage objects
            addObject(new Grass01(), 832, 233);
            
            //Row 6
            //Detectors
            addObject(new RightPlatCornerDetect(), 576, 230);
            addObject(new WallDetect(), 862, 230);
            //Platforms
            addObject(new Platform01(), 0, 228);
            addObject(new Platform01(), 64, 228);
            addObject(new Platform01(), 128, 228);
            addObject(new Platform01(), 192, 228);
            addObject(new Platform01(), 256, 228);
            addObject(new Platform01(), 320, 228);
            addObject(new Platform01(), 384, 228);
            addObject(new Platform01(), 448, 228);
            //Ground Tiles
            addObject(new Ground(), 0, 228);
            addObject(new Ground(), 64, 228);
            addObject(new Ground(), 128, 228);
            addObject(new Ground(), 192, 228);
            addObject(new Ground(), 256, 228);
            addObject(new Ground(), 320, 228);
            addObject(new Ground(), 384, 228);
            addObject(new Ground(), 448, 228);
            addObject(new Ground02(), 512, 228);
            addObject(new Ground09(), 576, 228);
            addObject(new Ground03(), 896, 228);
            addObject(new Ground02(), 960, 228);
            addObject(new Ground02(), 1024, 228);
            addObject(new Ground02(), 1088, 228);
            //Stage Objects
            addObject(new Palmtree01(), 256, 118);
            
            //Row 7
            //Detectors
            addObject(new BadnikDetectGoRight(), 168, 163);
            addObject(new BadnikDetectGoLeft(), 476, 163);
            addObject(new WallDetect(), 478, 168);
            addObject(new WallDetectRightWall(), 610, 168);
            addObject(new WallDetect(), 862, 168);
            //Platforms
            addObject(new Platform01(), 512, 164);
            addObject(new Platform01(), 576, 164);
            addObject(new Platform01(), 896, 164);
            addObject(new Platform01(), 960, 164);
            addObject(new Platform01(), 1024, 164);
            addObject(new Platform01(), 1088, 164);
            //Ground Tiles
            addObject(new Ground05(), 512, 164);
            addObject(new Ground06(), 576, 164);
            addObject(new Ground05(), 896, 164);
            addObject(new Ground(), 960, 164);
            addObject(new Ground(), 1024, 164);
            addObject(new Ground(), 1088, 164);
            //Stage Objects
            addObject(new Crabmeat(), 385, 165);
            addObject(new Grass01(), 512, 105);
        }
        if(drawRoom == 7)
        {
            //Row 0
            //Platforms
            addObject(new Platform01(), 0, 612);
            addObject(new Platform01(), 64, 612);
            addObject(new Platform01(), 128, 612);
            addObject(new Platform01(), 192, 612);
            addObject(new Platform01(), 256, 612);
            addObject(new Platform01(), 320, 612);
            addObject(new Platform01(), 384, 612);
            addObject(new Platform01(), 448, 612);
            addObject(new Platform01(), 512, 612);
            addObject(new Platform01(), 576, 612);
            addObject(new Platform01(), 640, 612);
            addObject(new Platform01(), 704, 612);
            addObject(new Platform01(), 768, 612);
            addObject(new Platform01(), 832, 612);
            //Ground Tiles
            addObject(new Ground(), 0, 612);
            addObject(new Ground(), 64, 612);
            addObject(new Ground(), 128, 612);
            addObject(new Ground(), 192, 612);
            addObject(new Ground(), 256, 612);
            addObject(new Ground(), 320, 612);
            addObject(new Ground(), 384, 612);
            addObject(new Ground(), 448, 612);
            addObject(new Ground(), 512, 612);
            addObject(new Ground(), 576, 612);
            addObject(new Ground(), 640, 612);
            addObject(new Ground(), 704, 612);
            addObject(new Ground(), 768, 612);
            addObject(new Ground(), 832, 612);
            addObject(new Ground02(), 896, 612);
            addObject(new Ground02(), 960, 612);
            addObject(new Ground02(), 1024, 612);
            addObject(new Ground02(), 1088, 612);
    }
}
    public void roomChangeUp()
    {
        if(drawRoom < drawRoomMax)
            drawRoom++;
        drawRooms();
    }
    public void roomChangeDown()
    {
        if(drawRoom > 0)
            drawRoom--;
        drawRooms();
    }
}